%
% This is the first encoder script for
%
%   storebror by Pex 'Mahoney' Tufvesson, August 2011
%
%
% Want to know more?  http://mahoney.c64.org
% Want to hear C64 a cappella?  Visa Rster at http://www.livet.se/visa
% Want a happy life? Do something _not_ requiring electricity! :-D
%

format long;
format compact;
clear;

loadFormantFile = 0;
loadRmsFile = 0;
loadX2File = 0;

% Takes any song and extracts something from it.
debugging = 2;
Fs = 44100;

% Noteno, 1=55 Hz=A in octave 2
noteNo=(0:60);
twelfthRootOfTwo=2 .^ (1/12); % =1.059463094;
Hz = 55 * ( twelfthRootOfTwo .^ noteNo );

%;Vers:
%;Akta dig fr storebror
%;c2c2 c2  b1  b1 a1 a1
%;Han ser mera n du nnsin tror
%;g1  a1  b1b1 b1 a1 a1 g1  g1
%;Ntet pejlas in ikvll
%;e1 g1 e1 d1  d1 c1 c1 
%;Du e kanske kriminell
%;c1 d1 e1g1  e1 d1 e1
%
%;inte facebook
%;b0d1 b0  a0
%
%;Anvnda noter i vers:   9st  a0-c2
%;c2 b1 a1 g1 e1 d1 c1 b0 a0
%
%;Ref:
%;Hur har det kunnat bli s kallt
%;b1  b1  b1  a1 a1  g1  g1  f#1
%;d1  d1  d1  c#1c#1 d1  d1  d1
%;b0  b0  b0  b0 b0  b0  b0  b0
%;storebror vet inte   allt
%;b1 b1 a1  a1  a1g1   f#1
%;a1 e1 f#1 g1  e1e1   d1
%;b0 c#1d1  e1  c#1c#1 b0
%;krlek skratt en doft av klver
%;b1 b1  a1     a1 g1   g1 f#1f#1
%;d1 g1  e1     f#1e1   f#1d1 d1
%;b0 d1  c#1    d1 c#1  f1 b0 b0
%;det r snt som vi behver
%;b1  b1 a1   a1  a1 g1f#1f#1
%;f#1 f#1f1   e1  e1 e1e1 e1
%;d1  c#1c#1  c#1 d1 d1d1 d1
%
%;Anvnda noter i ref:    9st
%;b1 a1 g1 f#1 f1 e1 d1 c#1 b0
%
%;Totalt anvnda noter: c2 b1 a1 g1 f#1 f1 e1 d1 c#1 c1 b0 a0  = 12 st



%The note values used through the whole song are:
%;Totalt anvnda noter:
%c2  Hz(28)
%b1  Hz(27)
%a1  Hz(25)
%g1  Hz(23)
%f#1 Hz(22)
%f1  Hz(21)
%e1  Hz(20)
%d1  Hz(18)
%c#1 Hz(17)
%c1  Hz(16)
%b0  Hz(15)
%a0  Hz(13)

%Lowest note:
Hz(13)   %     110.0000000000000
     
%Highest note:
Hz(28)   %     261.6255653005989

% With a sample frequency of 7812.5, this corresponds to certain number of
% samples:

% Some short calculations:
c64Fs = 7812.5;

lowestHz = Hz(13);
highestHz = Hz(28);
nofSamplesInLowestNote = c64Fs / lowestHz    %  71.022727272727252
nofSamplesInHighestNote = c64Fs / highestHz    %   29.861378382589265

% Assume every waveform is 64 bytes
% Then, we could have 128 waveforms = 8kB of waveform tables
% We would need pitch tables, that looked like this:
%pitch_13: 00 01 02 02 03 04 05 05 06 07 08 08 ... 3e 3f 3f 00 01 02 02 03...
%pitch_15
%pitch_16
%pitch_17
%...
%pitch_28: 00 02 04 07 09 0b 0e ... 3e 00 02 05 ...

%Every pitch table would need to be 
% (length of one period) + (length of one "batch" run)
%Assume we want to have 2 render loop runs per frame.
%We would then need to render 312/2 = 156 / 2 = 78 samples per render.
% This means that the pitch tables would occupy something like
%12 * (78 + 64) = 1704 bytes, which is "nothing"...!

waveformLength = 64;
renderLength = 78;

%...and, let's make some dummy waveforms...
filename = sprintf('dummy_waveforms.s');
fid = fopen(filename,'w');
fprintf(fid,'; Dummy waveforms.\n');
fprintf(fid,'; Generated on the %s\n',date);
fprintf(fid,'; Pex Mahoney Tufvesson, 2011\n');
fprintf(fid,'\n');
for waveformNo=1:128,
    fprintf(fid,'waveform_%d_start:\n',waveformNo-1);
    index = 0;
    for i = 1:waveformLength
        fprintf(fid,'  .byte %d\n',floor(i-1));
    end
    fprintf(fid,'waveform_%d_end:\n',waveformNo-1);
    fprintf(fid,'\n');
end
fclose(fid);




%
%;Vers1a:Akta dig fr storebror
%;    1b:Han ser mera n du nnsin tror
%;    1c:Ntet pejlas in ikvll
%;    1d:Du e kanske kriminell
%;Ref:   Hur har det kunnat bli s kallt
%;       storebror vet inte allt
%;       krlek skratt en doft av klver
%;       det r snt som vi behver
%;vers1e:inte facebook
%;Vers2a:Storebror bevakar oss
%;    2b:varje telefonmast hittar oss
%;    2c:Militr frn FRA
%;    2d:Kollar dina mail var dag
%;Ref:
%;vers2e:inte email
%;Vers3a:Akta dig fr storebror
%;    3b:Han ser mera n du nnsin tror
%;    3c:Nineteenhundredeightyfour
%;    3d:Fyller tjugosju i r
%;Ref:
%;vers3e:inte android
%





% Time to collect all wav-files into one array/matrix.
folder = 'audio_1st_try'
[v1a,Fs,bits]=wavread([folder '/vers_Xa32 - 06 - Audio - vers1']);
[v1b,Fs,bits]=wavread([folder '/vers_Xb32 - 06 - Audio - vers1']);
[v1c,Fs,bits]=wavread([folder '/vers_Xc32 - 06 - Audio - vers1']);
[v1d,Fs,bits]=wavread([folder '/vers_Xd32 - 06 - Audio - vers1']);
[v1e,Fs,bits]=wavread([folder '/vers_Xe32 - 06 - Audio - vers1']);
[v2a,Fs,bits]=wavread([folder '/vers_Xa32 - 07 - Audio - vers2']);
[v2b,Fs,bits]=wavread([folder '/vers_Xb32 - 07 - Audio - vers2']);
[v2c,Fs,bits]=wavread([folder '/vers_Xc32 - 07 - Audio - vers2']);
[v2d,Fs,bits]=wavread([folder '/vers_Xd32 - 07 - Audio - vers2']);
[v2e,Fs,bits]=wavread([folder '/vers_Xe32 - 07 - Audio - vers2']);
%[v3a,Fs,bits]=wavread([folder '/vers_Xa32 - 08 - Audio - vers3']);
%[v3b,Fs,bits]=wavread([folder '/vers_Xb32 - 08 - Audio - vers3']);
[v3c,Fs,bits]=wavread([folder '/vers_Xc32 - 08 - Audio - vers3']);
[v3d,Fs,bits]=wavread([folder '/vers_Xd32 - 08 - Audio - vers3']);
[v3e,Fs,bits]=wavread([folder '/vers_Xe32 - 08 - Audio - vers3']);
[ref,Fs,bits]=wavread([folder '/ref_X32 - 07 - Audio - vers2']);

v1a = v1a(:,1);
v1b = v1b(:,1);
v1c = v1c(:,1);
v1d = v1d(:,1);
v1e = v1e(:,1);
v2a = v2a(:,1);
v2b = v2b(:,1);
v2c = v2c(:,1);
v2d = v2d(:,1);
v2e = v2e(:,1);
%v3a = v3a(:,1);
%v3b = v3b(:,1);
v3c = v3c(:,1);
v3d = v3d(:,1);
v3e = v3e(:,1);
ref = ref(:,1);

nof_audio_files = 14;
maxlen = size(ref);
maxlen = maxlen(1)

all_audio = zeros(nof_audio_files,maxlen);

all_audio(1,1:length(v1a))=v1a;
all_audio(2,1:length(v1b))=v1b;
all_audio(3,1:length(v1c))=v1c;
all_audio(4,1:length(v1d))=v1d;
all_audio(5,1:length(v1e))=v1e;
all_audio(6,1:length(v2a))=v2a;
all_audio(7,1:length(v2b))=v2b;
all_audio(8,1:length(v2c))=v2c;
all_audio(9,1:length(v2d))=v2d;
all_audio(10,1:length(v2e))=v2e;
%all_audio(11,1:length(v3a))=v3a;
%all_audio(12,1:length(v3b))=v3b;
all_audio(11,1:length(v3c))=v3c;
all_audio(12,1:length(v3d))=v3d;
all_audio(13,1:length(v3e))=v3e;
all_audio(14,1:length(ref))=ref;

% Let's normalize all audio into +1.0 to -1.0 just for fun...
for audioNo=1:nof_audio_files,
    maxp = max(all_audio(audioNo,:));
    minp = min(all_audio(audioNo,:));
    coef = max(maxp, -minp);
    all_audio(audioNo,:) = all_audio(audioNo,:) ./ coef;
end

%Visualize all of the audio:
figNo = 1
figure(figNo)
nofInEach = 4;
for audioNo=1:nof_audio_files,
    figure(floor((audioNo-1) / nofInEach) + figNo)
    subplot(nofInEach,1,audioNo - floor((audioNo-1) / nofInEach)*nofInEach);
    a=all_audio(audioNo,:);
    t=1:length(a);
    plot(t,a);
end
figNo = figNo + 4;



% How many slices per seconds will we process?
sliceRate = 100;

% We don't care about pitch really,
% but we need it to make a constant pitch audio file...
%want to detect pitch "approximately" every XXXms.
sliceSecondsTarget = 1 / sliceRate;


% Input audio is 44100Hz, 16-bit.

% Each slice is:
sliceLength = round(Fs * sliceSecondsTarget) %#ok<NOPTS>
% This is what we really got:
sliceSeconds = sliceLength / Fs %#ok<NOPTS>
% Calculate "how wrong" the speed will be due to rounding
% the sliceLength to an integer number of 16-bit audio samples.
timeSkew = (sliceSecondsTarget - sliceSeconds) / sliceSecondsTarget %#ok<NOPTS>



% Now, to simplify things, let's join the audio matrix into one
% audio vector. And add a little silence to the start+end of it. (2*Half a slice)
alen = size(all_audio);
alen = alen(2)
roundToSlices = floor(alen / sliceLength) * sliceLength;
originalAudio = [ zeros(1,floor(sliceLength/2)) all_audio(1,1:roundToSlices) all_audio(2,1:roundToSlices) all_audio(3,1:roundToSlices) all_audio(4,1:roundToSlices) all_audio(5,1:roundToSlices) all_audio(6,1:roundToSlices) all_audio(7,1:roundToSlices) all_audio(8,1:roundToSlices) all_audio(9,1:roundToSlices) all_audio(10,1:roundToSlices) all_audio(11,1:roundToSlices) all_audio(12,1:roundToSlices) all_audio(13,1:roundToSlices) all_audio(14,1:roundToSlices) zeros(1,floor(sliceLength/2))];



originalAudioLength = length(originalAudio) %#ok<NOPTS>
nofSlices = floor(originalAudioLength / sliceLength) %#ok<NOPTS>

%Now determine which overlap we want when doing FFT calculations.
%(and all other slice calculations as well)
%Making a slice double length is probably a good idea.
overlap = 2.0;
oversampling = 8;
fftLength = ceil(overlap * sliceLength) %#ok<NOPTS>

%Time to choose a windowing function for calculations:
fftWindow=hanning(fftLength);

%t=1:originalAudioLength;


% Need to do calculations incrementally, since memory requirements
% may get out of hand if doing all at once.
% Must avoid doing global calculations like max(all) or mean(all)



% Could use a filter with a bandpass filter with stopband defined from 0 to 120Hz
% and passband defined from 140 Hz to 300 Hz.
% Specify a passband ripple of 5%
% ...but to make things faster, we'll "only" do a low pass filter
% which passes all frequencies below 330 Hz, and stops all frequencies
% above 370Hz. Ripple 0.1. This is an "easier" filter that doesn't
% require as many bins/as high order as the bandpass version.
% ..and the original audio is a cappella already, so it should be pretty
% quiet below 120Hz anyway!

% This is the filter, if we decide to use it:
fsamp = Fs;
%fcuts = [100 120 300 350];
%mags = [0 1 0];
%devs = [0.1 0.1 0.1];
fcuts = [300 340];
mags = [1 0];
devs = [0.1 0.1];
[n,Wn,beta,ftype] = kaiserord(fcuts,mags,devs,fsamp);
hh = fir1(n,Wn,ftype,kaiser(n+1,beta),'noscale');
figure(figNo);
figNo = figNo + 1;
freqz(hh);


% Now reserve memory for all the different pitch detection methods:
Formant0 = zeros(1,nofSlices);


if loadFormantFile == 1,
    % We have a file with the data, no need to calculate it again:
    % This is to speed things up if we already have run this part.
    load 'matlab_Formant0.mat'  % Contains Formant0
else
    % If we want this process to go faster...
    %    nofSlices = 800;

    for sliceNo=1:nofSlices-2,
        sliceNo %#ok<NOPTS>
        sliceMiddleIndex = round((sliceNo + overlap/2) * sliceLength + 1) %#ok<NOPTS>
        sliceStartIndex = ceil(sliceMiddleIndex - (sliceLength/2)) %#ok<NOPTS>
        sliceEndIndex = floor(sliceMiddleIndex + (sliceLength/2)) %#ok<NOPTS>
        sliceStartIndexOverlap = ceil(sliceMiddleIndex - (fftLength/2)) %#ok<NOPTS>
        sliceEndIndexOverlap = floor(sliceMiddleIndex + (fftLength/2) - 1) %#ok<NOPTS>

        %The time domain way of getting base frequency:
        %This code plots the autocorrelation function for a section of audio signal:
        fs = Fs*oversampling;
        ms2=floor(fs/310);                 % maximum speech Fx
        ms20=floor(fs/120);                 % minimum speech Fx
%        x = originalAudio((sliceNo*fftLength/2+1):(sliceNo*fftLength/2+(fftLength/2)))';
%        x = (detrend(originalAudio((sliceNo*fftLength/2+1):(sliceNo*fftLength/2+fftLength))))';
        x = (detrend(originalAudio(sliceStartIndexOverlap:sliceEndIndexOverlap))).*fftWindow';
        x = resample(x,oversampling,1); % Use oversampling
%        x = (detrend(originalAudio((sliceNo*fftLength/2+1):(sliceNo*fftLength/2+fftLength)))).*W;
%        extraMargin = size(hh);
%        extraMargin=extraMargin(2);
%        x = filter(hh,1,[x']);        
        if debugging==3
            % plot waveform
            figure(figNo);
            figNo = figNo + 1;
            lenx = size(x);
            lenx = lenx(2);
            t=(0:lenx-1)/fs;        % times of sampling instants
            subplot(2,1,1);
            plot(t,x);
            legend('Waveform');
            xlabel('Time (s)');
            ylabel('Amplitude');
        end
        % calculate autocorrelation
        r=xcorr(x,ms20,'coeff');   
        if debugging==3
            % plot autocorrelation
            d=(-ms20:ms20)/fs;          % times of delays
            subplot(2,1,2);
            plot(d,r);
            legend('Autocorrelation');
            xlabel('Delay (s)');
            ylabel('Correlation coeff.');
        end
        %You can see that the autocorrelation function peaks at zero delay and at delays corresponding to ?? 1 period,  ?? 2 periods, etc.  We can estimate the fundamental frequency by looking for a peak in the delay interval corresponding to the normal pitch range in speech, say 2ms(=500Hz) and 20ms (=50Hz).  For example:
        % just look at region corresponding to positive delays
        r=r(ms20+1:2*ms20+1);
        [rmax,tx]=max(r(ms2:ms20));
%        fprintf('rmax=%g Fx=%gHz\n',rmax,fs/(ms2+tx-1));
        frequency = fs/(ms2+tx-1);
        Formant0(sliceNo)=frequency;        
    end

    save 'matlab_Formant0.mat' Formant0

    figure(figNo);
    figNo = figNo + 1;
    clf;
    plot(Formant0,'b');         %Works pretty ok, seems to always say 10Hz higher than the rest

end

%The time domain pitch detection works best here, let's use that one.

%sound(originalAudio,Fs);






% Now, extract some kind of very simple volume envelope for this.
%Should probably be sime kind of "When too much noise, be silent"
%When nothing at all, be silent.
%Else, be full volume.

SIDVoiceVolume = zeros(1,nofSlices);
rms = zeros(1,nofSlices);
rmsHigh = zeros(1,nofSlices);
rmsLow = zeros(1,nofSlices);

%Design a highpass filter with stopband defined from 0 to 3500Hz
% and passband defined from 4000 Hz to 20 kHz.
% Specify a passband ripple of 5% and a stopband attenuation of 40 dB:

fsamp = Fs;
fcuts = [3500 4000];
mags = [0 1];
devs = [0.05 0.01];
[n,Wn,beta,ftype] = kaiserord(fcuts,mags,devs,fsamp);
hh = fir1(n,Wn,ftype,kaiser(n+1,beta),'noscale');
figure(figNo);
figNo = figNo + 1;
freqz(hh)

%Design a lowpass filter with passband defined from 0 to 3500Hz
% and stopband defined from 4000 Hz to 20 kHz.
% Specify a passband ripple of 5% and a stopband attenuation of 40 dB:
mags = [1 0];
devs = [0.05 0.01];
[n,Wn,beta,ftype] = kaiserord(fcuts,mags,devs,fsamp);
hhlow = fir1(n,Wn,ftype,kaiser(n+1,beta),'noscale');
figure(figNo);
figNo = figNo + 1;
freqz(hhlow)

overlapSample = 50; %nofSamples to include "outside" the slice










if loadRmsFile == 1
    load 'matlab_Rms.mat'  % Contains rms, rmsHigh, rmsLow
else
    for sliceNo=1:nofSlices-2,
        sliceNo %#ok<NOPTS>
        sliceMiddleIndex = round((sliceNo + overlap/2) * sliceLength + 1) %#ok<NOPTS>
        sliceStartIndex = ceil(sliceMiddleIndex - (sliceLength/2)) %#ok<NOPTS>
        sliceEndIndex = floor(sliceMiddleIndex + (sliceLength/2)) %#ok<NOPTS>
        sliceStartIndexOverlap = ceil(sliceMiddleIndex - (fftLength/2)) %#ok<NOPTS>
        sliceEndIndexOverlap = floor(sliceMiddleIndex + (fftLength/2) - 1) %#ok<NOPTS>

        sliceLen2 = sliceEndIndex-sliceStartIndex+overlapSample*2;
        W = hanning(sliceLen2);
        % Time to estimate the noise in here:
        sliceData = detrend(originalAudio(sliceStartIndex-overlapSample:sliceEndIndex+overlapSample-1))' .* W;
        
        % Making the slice zero mean:
%        sliceData = detrend(originalAudio(sliceStartIndexOverlap:sliceEndIndexOverlap)).*fftWindow;

        %This example uses norm(x)/sqrt(n) to obtain the root-mean-square (RMS) value of an n-element vector x.
        %x = [0 1 2 3]
        %sqrt(0+1+4+9)   % Euclidean length
        %ans =
        %    3.7417
        %norm(x)
        %ans =
        %    3.7417
        %n = length(x)   % Number of elements
        %rms = 3.7417/2  % rms = norm(x)/sqrt(n)

        len = size(sliceData);
        len = len(1);
        rms(sliceNo) = norm(sliceData) / len;

        % Now, extract "how much noise" there is above 4kHz.
        % If too much, be silent.
        % Make a high pass filtered version of x
        
        xhigh = filter(hh,1,[sliceData' zeros(1,overlap*3)]);
        rmsHigh(sliceNo) = norm(xhigh) / len;

        xlow = filter(hhlow,1,[sliceData' zeros(1,overlap*3)]);
        rmsLow(sliceNo) = norm(xlow) / len;
    end
    % Save all calculated values to file:  
    save 'matlab_Rms.mat' rms*
end

figure(figNo);
figNo = figNo + 1;
clf;
plot(rms);
hold on;
plot(rmsHigh,'y');
plot(rmsLow,'r');
legend('RMS','RMS for high frequencies > 4kHz','RMS for low frequencies < 4kHz');

% From the plot above, we shall be silent when rmsHigh > rmsLow.
maxRmsLow = max(rmsLow);
threshold = maxRmsLow * 0.03;
plot([0 nofSlices],[threshold threshold],'g');



for sliceNo=1:nofSlices-1,
    %We don't have a separate noise channel this time, so we better include
    %the noise
%    if ((rmsLow(sliceNo) > rmsHigh(sliceNo)) && (rmsLow(sliceNo) > threshold))
%    if (rmsLow(sliceNo) > threshold)
    if (rms(sliceNo) > threshold)
%        SIDVoiceVolume(sliceNo) = rmsLow(sliceNo+1);
        SIDVoiceVolume(sliceNo) = 1;
    else
        SIDVoiceVolume(sliceNo) = 0;
    end
end


% Make frequencies "nicer". First of all,
% remove all lonely spurious slices. A slice with volume>0 that has only
% "silent neighbours" V(n-1)=0 and V(n+1)=0 will be set to silent.
for sliceNo=2:nofSlices-2,
    if SIDVoiceVolume(sliceNo)~=0
        if ((SIDVoiceVolume(sliceNo-1)==0) && (SIDVoiceVolume(sliceNo+1)==0))
            SIDVoiceVolume(sliceNo) = 0;
        end
    end
end

% Make frequencies "nicer". Now, fill in the gaps.
% Remove all lonely silent slices. A slice with volume=0 that has only
% "noisy neighbours" V(n-1)!=0 and V(n+1)=!0 will be set to volume=1.
for sliceNo=2:nofSlices-2,
    if SIDVoiceVolume(sliceNo)==0
        if ((SIDVoiceVolume(sliceNo-1)~=0) && (SIDVoiceVolume(sliceNo+1)~=0))
            SIDVoiceVolume(sliceNo) = 1;
        end
    end
end
save 'matlab_SIDVoiceVolume.mat' SIDVoiceVolume

maxF0 = max(Formant0);
figure(figNo);
figNo = figNo + 1;
clf;
plot(SIDVoiceVolume,'.');
hold on;
plot(rmsLow / maxRmsLow,'y');
legend('SIDVoiceVolume','rms low frequencies < 4kHz');
plot(Formant0 ./ maxF0 .* SIDVoiceVolume,'r.');




%Now, cap the Formant0 frequencies to be between 120Hz and 320Hz.
baseFreq = Formant0;

% It's done already, we'll skip this part...
% for sliceNo=0:nofSlices-2,
%     if baseFreq(sliceNo+1) > 610
%         baseFreq(sliceNo+1) = baseFreq(sliceNo+1) / 2;
%     end
%     if baseFreq(sliceNo+1) < 290
%         baseFreq(sliceNo+1) = baseFreq(sliceNo+1) * 2;
%     end
%     if baseFreq(sliceNo+1) < 290
%         baseFreq(sliceNo+1) = baseFreq(sliceNo+1) * 2;
%     end
%     if (SIDVoiceVolume(sliceNo+1) == 0)
%         baseFreq(sliceNo+1) = 0;
%     end
%     
% end


x=1:nofSlices;
x2=[1 nofSlices];
figure(figNo);
figNo = figNo + 1;
clf;
%plot(x,baseFreq,'.');
plot(x, baseFreq .* SIDVoiceVolume,'.');
hold on;
plot(x2,[Hz(13) Hz(13)],'r');
plot(x2,[Hz(15) Hz(15)],'r');
plot(x2,[Hz(16) Hz(16)],'r');
plot(x2,[Hz(17) Hz(17)],'r');
plot(x2,[Hz(18) Hz(18)],'r');
plot(x2,[Hz(20) Hz(20)],'r');
plot(x2,[Hz(21) Hz(21)],'r');
plot(x2,[Hz(22) Hz(22)],'r');
plot(x2,[Hz(23) Hz(23)],'r');
plot(x2,[Hz(25) Hz(25)],'r');
plot(x2,[Hz(27) Hz(27)],'r');
plot(x2,[Hz(28) Hz(28)],'r');



% Now count the number of "phrases". The definition of
% phrase is a continuous block where the SIDVoiceVolume = 1
nofPhrases = 0;
for sliceNo=2:nofSlices-2, %Don't do the first one or the last one...
    if ((SIDVoiceVolume(sliceNo) == 1) && (SIDVoiceVolume(sliceNo-1)==0))
        nofPhrases = nofPhrases + 1;
    end
end

% There are ~276 phrases. Using "sliding granular synthesis" without
% pitching would give us approximately 32768/nofPhrases = 118 bytes per
% phrase. This is probably too little.



oversamplingRatio = 2;

if (loadX2File == 1)
    load 'matlab_filteredAudioX2'
else
    % Time to resample the originalAudio into contant-pitch audio.
    % We need to keep track of "sliceMiddleIndex" and its
    % corresponding pitch.

    % We can run out of memory while doing this, so make the oversampling
    % ratio variable:

    originalAudioX = resample(originalAudio,oversamplingRatio,1); % Use oversampling

    % Filter the audio to remove "vikningseffekten" mirroring unwanted
    % frequencies down in the pass band by exceeding the Nyqvist frequency.
    % We will have a 7812.5Hz sample rate, so we'll need to remove
    % frequencies above 3906kHz.
    % Note that we will pitch this down _after_ we've done this
    % filtering, and then pitch it back up again. So we can happily
    % use a straight 3.5kHz cutoff frequency for this one. Not really true,
    % since slices with different pitch will match to the same waveform.
    % But, hey, who's perfect? ;)

    fsamp = Fs*oversamplingRatio;
    %fcuts = [120 140 330 370];
    %mags = [0 1 0];
    %devs = [0.1 0.1 0.1];
%This was a little "dull"
    %    fcuts = [3510 3906];
% This was better:    
%    fcuts = [3610 4006];
%And, this is just a bold try:
    fcuts = [3810 4106];
    mags = [1 0];
    devs = [0.1 0.1];
    [n,Wn,beta,ftype] = kaiserord(fcuts,mags,devs,fsamp);
    hh = fir1(n,Wn,ftype,kaiser(n+1,beta),'noscale');
    figure(figNo);
    figNo = figNo + 1;
    freqz(hh);

    % Make a zero-phase filtering, to make sure that
    % the slice middle index actually points to almost
    % the same spot in the audio material.
    filteredAudioX = filtfilt(hh,1,originalAudioX);
    save 'matlab_filteredAudioX2' filteredAudioX
end


%Then, resample (non-integer resampling) with a
% spline-shaped pitch curve locally around the slice to make the 
% base frequencies equal.
% Find a wavetable that _includes_ the middle sample.
% Let the middle sample be the "positive peak value" of the wavetable.

% pitch
% ^
% |  X..
% |     ..
% |       .       ...X
% |        ..X....
% |-------------------> time
%

% The "new" time axis will be calculated by looking at the
% values of the pitch.
% We have pitch values on each slice.
% Make the spline to approximate pitch for _all_ audio values.
% First of all, calculate all the middleIndices
sliceMiddleIndices = zeros(1,nofSlices);
for sliceNo=1:nofSlices-1,
    sliceMiddleIndices(sliceNo) = round((sliceNo + overlap/2) * sliceLength + 1);
end

% Now, find pitch values corresponding to all filteredAudioX indices:
len = length(originalAudio);
xx = 1:len;
originalAudioPitch = spline(sliceMiddleIndices,baseFreq,xx);
figure(figNo);
figNo = figNo + 1;
plot(sliceMiddleIndices(1:100),baseFreq(1:100),'o',xx(1:10000),originalAudioPitch(1:10000));

% Now walk through filteredAudioX with a speed corresponding to the pitch.
% This will tune all singing to be the same pitch throughout the song.
% What frequency do we want the singing to be?
% We want to extract wavetables from the audio. One wavetable should be
% an integer number of words, and 
% the "lowest" frequency we want contains 53.206927445904853
% samples@7812.5Hz.
% This means that we choose a wave table length of 51 samples, which will
% fit nicely with 5 wave tables per 256 bytes.

% The frequency of filteredAudioX is 
filteredFs=Fs*oversamplingRatio
% To pick out 51 integer values when the pitch is 146.8323839587038Hz
% (Hz(18)):
% The filteredAudioX for Hz(18) contains 
Hz18nofSamples = filteredFs / Hz(18)
% samples

% We want every other frequency to contain the same number of samples.
% The speed to "walk through" the sample will be:
note=24
Hz(18) / Hz(note) * oversamplingRatio

% This will make the output audio be Fs Hz (most often 44100Hz, for easy
% listening).

filteredAudioXIndex = 2;
filteredAudioXLength = length(filteredAudioX);
constantPitchAudioIndex = 2;
finished = 0;

constantPitchAudio = zeros(1,length(filteredAudioX)); % Not quite right, but good enough...




% We need to keep track of "where" the original middleIndices went in our
% new constantPitchAudio. New record for long variable name. Whoppie!
sliceMiddleIndexConstantPitchAudio = zeros(1,nofSlices);

while (filteredAudioXIndex < filteredAudioXLength)
    % Bad zero-order interpolation:
    %pitch = filteredAudioXPitch(floor(filteredAudioIndex));
    % Better linear interpolation:
    originalAudioIndex = filteredAudioXIndex / oversamplingRatio;
    frac = originalAudioIndex - floor(originalAudioIndex);
    pitch = originalAudioPitch(floor(originalAudioIndex)) * (1-frac) + originalAudioPitch(floor(originalAudioIndex)+1) * frac;
    % The spline-interpolated pitch can and will be negative, due to
    % rand-factors and BadThings(tm). So, let's make it a little bit more
    % sane:
    if (pitch < 100)
        pitch = 100;
    end
    speed = Hz(18) / pitch * oversamplingRatio;

    % Linear interpolation for sample values has to be enough as well:
    frac = filteredAudioXIndex - floor(filteredAudioXIndex);
    constantPitchAudio(constantPitchAudioIndex) = filteredAudioX(floor(filteredAudioXIndex)) * (1-frac) + filteredAudioX(floor(filteredAudioXIndex)+1) * frac;

    % Save the index for later. We only need an integer index, so don't
    % care about doing this precisely.
    %sliceNo = ..... ToDo...
    %sliceMiddleIndices(sliceNo) = round((sliceNo + overlap/2) * sliceLength + 1);
    %index = (sliceNo + overlap/2) * sliceLength + 1;
    %(index-1)/sliceLength = sliceNo + overlap/2;
    %(index-1)/sliceLength - overlap/2 = sliceNo;
    sliceNo = (filteredAudioXIndex/oversamplingRatio - 1) / sliceLength - overlap/2;
    if (sliceNo <= 0)
        sliceNo = 1;
    end
    sliceMiddleIndexConstantPitchAudio(ceil(sliceNo)) = constantPitchAudioIndex;
    
    % Increment indices:
    filteredAudioXIndex = filteredAudioXIndex + speed;
    constantPitchAudioIndex = constantPitchAudioIndex + 1;
end

% Now, constantPitchAudio contains the whole song, at Fs Hz,
% with all frequencies pitched "down" to Hz(18) = 146.8323839587038 Hz

constantPitchAudio=constantPitchAudio(1:constantPitchAudioIndex);
save 'matlab_constantPitchAudio' constantPitchAudio
wavwrite(constantPitchAudio,Fs,16,'constantPitchAudio16.wav');
save 'matlab_sliceMiddleIndexConstantPitchAudio' sliceMiddleIndexConstantPitchAudio



% Wavetable extraction

% Let's grab one loopable waveform around every
% sliceMiddleIndexConstantPitchAudio
% Let the sliceMiddleIndex be in the middle of the waveform,
% and not "The first positive zero-crossing to the left of the peak",
% as it used to be.
% And, let's use just the non-silent ones.

waveformLength = round(Fs / Hz(18));   %="Almost" 300
waveforms = zeros(nofSlices,waveformLength);
waveformsNormalized = zeros(nofSlices,waveformLength);
usedSliceIndex = 1;

for sliceNo=2:nofSlices-3, %Don't do the first one or the last one...
    sliceNo
    if (SIDVoiceVolume(sliceNo) ~= 0)
        sliceMiddleIndex = sliceMiddleIndexConstantPitchAudio(sliceNo) %#ok<NOPTS>
        sliceStartIndex = floor(sliceMiddleIndex - waveformLength/2);
        sliceEndIndex = floor(sliceMiddleIndex + waveformLength/2)-1;

        %We have found our waveform:
        waveformStartIndex = sliceStartIndex;
        waveformEndIndex = sliceEndIndex;

        maxValue = max(constantPitchAudio(waveformStartIndex:waveformEndIndex));
        minValue = min(constantPitchAudio(waveformStartIndex:waveformEndIndex));
        extremeValue = max(maxValue, -minValue);

        % Copy the waveform, normalized in the range [-1.0 .. 1.0]:
        waveforms(usedSliceIndex,:) = constantPitchAudio(waveformStartIndex:waveformEndIndex)';
        waveformsNormalized(usedSliceIndex,:) = constantPitchAudio(waveformStartIndex:waveformEndIndex)' ./ extremeValue;
        usedSliceIndex = usedSliceIndex + 1;
    end
end
waveforms = waveforms(1:usedSliceIndex,:);
waveformsNormalized = waveformsNormalized(1:usedSliceIndex,:);

save 'matlab_waveforms.mat' waveforms
save 'matlab_waveformsNormalized.mat' waveformsNormalized

% Here, usedSliceIndex = 9726
% And, sum(SIDVoiceVolume) = 9725
% This is correct


%The VIC-II was manufactured with 5 micrometer NMOS technology[1] and was clocked at 17,73447 MHz (PAL)
% Use a clock freqency of 985248Hz for PAL C64
% 17734470 / 18 = 985248.333 Hz
%PAL systems have 312 raster lines and 63 processor cycles on each raster line.
%Because a bad line will steal 40 cycles, there is only 23 cycles left on each scan line.

% PAL-B systems:
%            Chip      Crystal  Dot      Processor Cycles/ Lines/
%    Host    ID        freq/Hz  clock/Hz clock/Hz  line    frame
%    ------  --------  -------- -------- --------- ------- ------
%    C64     6569      17734472  7881988    985248      63    312
%The frame rate is 985248 /     63  /  312 =  50.1245 Hz
    
% We're going to play one 8-bit sample every other rasterline.
%P A L
%Phase Alternating Line SYSTEM	
%Line/Field	625/50	
%Horizontal Freq.	15.625 kHz	
%Vertical Freq.	50 Hz
%Color Sub Carrier	4.433618 MHz	
%Video Bandwidth	5.0 MHz	
%Sound Carrier	5.5 MHz
% This is a sample playback at 7812.5Hz

%985248/7812.5, we have 126 clock cycles available
% for every 8-bit sample output. Of these, lots of them
% get wasted by badlines drawing the characters on screen,
% and for sample playback timing synchronization, and sample playback.

% The lowest note we want to reproduce is 146Hz.
% With a sampling frequency of 7812.5Hz, this is a period of 53.5 samples.
% The highest note we want to reproduce is 294Hz.
% With a sampling frequency of 7812.5Hz, this is a period of 26 samples.

% Ideally, we would like to always "skip" samples, and never hold samples.
% This makes the resample-calculations easier on the Commodore64-side.
% Hence, waveforms should be at least 54 bytes long.
% Assume waveforms are 64 bytes long.
% Then, with 32kB available for waveforms, we have
% 32*1024/64 = 512 different waveforms available.

% Maybe we could make interpolation between waveforms. Then
% this will be enough.

% Inner loop of sample playback:
% ZeroCodeStart:
%         LDA     #$11
%         STA     $D404
%         LDA     #9
%         STA     $D404
% Poi:
%         LDA     $3000
%         STA     $D401
%         LDA     #1
%         STA     $D404
%         INC     Poi-ZeroCodeStart+ZeroCodeDest+1
% SaveAnmi:
%         LDA     #$A
%         JMP     $DD0C

% Need to "render" sound at $3000-$30ff to be able to do this properly.
% Need to double buffer the sound as well.
% Each buffer should be 10ms,
% This is 78.125 samples each iteration
% We need to cheat. Sample play cannot be syncronized with the screen
% raster line.
% We need to change the slice width to be something else than 10 ms,
% something that is easier to handle when it comes to mixing the
% formants.
% Using 128 bytes @ 7812.5 Hz gives us a resolution of 
%  16.384 ms
% Using 64 bytes gives us a resolution of
%   8.192 ms
% Assuming 64 byte long waveforms, this is a pretty logical choise.
% Then, the "lowest" pitch we can play will approximately change
% waveform every period, which is nice.
% The highest pitch will change waveform every second period, which
% I hope is enough. Hence, we don't need to make any linear
% fade between formant/wave tables. It can be static during the
% whole 64 byte mixing routine.

% Need to make a mixing routine that can handle:
%  64 byte long waveforms
%  "monophonic" pitch change
%  Linear interpolation between 2 waveforms with a couple of volume levels
%  Main volume level.

% Make one mixing routine for every crossfade ratio.
% One will do "only one wavetable at 100% volume - main volume=X%"
% One will do "wavetable0 at 75% volume - wavetable1 at 25%, main volume=X%"
% One will do "wavetable0 at 50% volume - wavetable1 at 50%, main volume=X%"
% One will do "wavetable0 at 25% volume - wavetable1 at 75%, main volume=X%"

% Wavetables will have the average value #$00, and
% range #-$40 - #$3f. Length = 64 bytes.

% We need to be able to start in the middle of a Pitch table,
% so it will need to be "one period" + 64 bytes long.
% A pitch table with speed = 1.0 will be 128 bytes long.
% A pitch table with speed = 2.0 will be 64/2.0 + 64 = 96 bytes long.
% A pitch table with speed = 4.0 will be 64/4.0 + 64 = 80 bytes long.
% The pitch table will contain the numbers 0,1,2, .. 63,0,1,2...
%  counting upwards with "the speed of the pitch".
% They can be easily calculated with 6502 assembly.
% Making all pitch tables 128 bytes long seems like a good choise.
% We have 9 different notes to play, that is 1152 bytes for tables.
% We could afford to have a couple of "out of tune" pitch tables as well
%  to handle vibrato/imperfection.

% Every 8.192ms we need to calculate:
% wavetable0 pointer (one out of 512) = 9 bits
% wavetable1 pointer                  = the previous wavetable0 pointer if
%                                       set (1 bit)
% volume ratio to choose: 100%, 75/25, 66/33, 50/50 = 2 bits
% Main output volume. 0..15           = 4 bits
% 9 + 1 + 2 + 4 = 15 bits
% Doing 16000 of these is 32kB with data.

% Memory budget:
% Noise table:                = 10kB
% Volume tables: 16*256 bytes = 4kB
% Pitch tables: 9 * 128       = 1152 bytes
% Wave tables: 512 * 64 bytes = 32kB
% Program memory 0000-17ff    = 6kB
% Screen                      = 1kB
% Note values                 = 1kB (note + length for the whole song)
% We have left: 64-10-4-1-32-6-1 = 9kB
% Noise table needs to be shorter, assume a 15kB for wavetable control and
%                                            4kB for noise control

% We could skip the volume tables, then use only 4 of them...
% Then we save 3kB memory for something else... like $d000-$dfff which
% is kind of difficult to use in this context anyway.

% We could also put a notch filter on the base frequency, and play that
% with a SID oscillator as well. Then, we ruin the possibility of playing
% bass sounds with SID, since all oscillators are taken.
% One for playing wavetables, one for playing noise, one for playing
% the base frequency of the vocals.

% Wavetable gathering algorithm:
%   Oversample the original audio x8 or something.
%   Pitch original audio into a period a multiple of 64 words.
%   Do this by changing the length of the complete song, but make
%   a table of where each 8.192ms-slice starts. (A floating point pointer!)
%   Do pitch changes soft - make a spline/linear interpolation
%   between pitches.
%   Make the resampling by "walking through the original audio"
%   with a variable speed. Use linear interpolation.

%   Try to extract 1 wavetable near the start of every splice (that has
%   a volume > 0). Try to find a peak, and extract 64 bytes around that one.
%   Low pass filter the wavetable, remove all content above 3.5kHz.
%   Resample down to 7812.5Hz.

%   Put all wavetables into a masssive table.
%   Try to eliminate every wavetable by comparing it to "older" wavetables
%   or even linear combinations (100,75/25,66/33 or 50/50) of older
%   wavetables. In the time domain.
%   Repeat and adjust parameters until approximately 500 wavetables are
%   left.

% Could also rely on "self modifying waveforms", by sometimes
% keeping a percentage of the last played waveform.
% Every modification to the current waveform playing would then
% be applied with 25%, 33%, 50%, 66%, 75% or 100%.
% 100% would replace the waveform completely.
% 25% would only change the waveform "a little".
% Then, only the "starting" waveforms will be stored as complete waveforms,
% and the rest will be "differential" changes applied to the starting
% waveforms.

% Adding non-pitched drums to this one is simple.
% Just add a ADC $abcd,y anywhere, and make sure that
% wavetables gets their overall volume lowered to avoid clipping.


%Trick: could use pha for storing samples
% PHA takes 3 clock cycles.
% To be compared with STA $aaaa,y = 5    + INY = 2
% PLA can not be used for playback, since this will pull samples
% in the wrong order. Playback will do something like LDA $0100
% where the low byte needs to be incremented.
% Raster interrupts are ok, since all calculations and PHAs will
% be done in the outermost loop. The calculations cannot be done
% with a subroutine that is JSRed to, though.
% Synchronizing will have to be done with TSX, checking when to 
% do more samples.

% The other way around is bad, since PLA cannot be used for playback
% if the CIA NMI irq happens to interrupt and already ongoing timer IRQ;
% Then, the PLA will fetch the wrong value.




% Replay with no mixing routine:

% IRQ handling                    7
%         STA     SaveAnmi+1      3
%         ...a few clocks sync 0 - 4 of them
%         JMP     ZeroCode        3
%ZeroCode:
%        LDA     #$11             2
%        STA     $D404            4
%        LDA     #9               2
%        STA     $D404            4
%Poi:
%        LDA     $3000            4
%        STA     $D401            4
%        LDA     #1               2
%        STA     $D404            4
%        INC     Poi+1            5
%SaveAnmi:
%        LDA     #$A              2
%        JMP     $DD0C            3
%DD0C:   RTI                      6
%                               =55-59 clocks in all
% We have 126-55 = 67-71 clocks left per sample for the mixing routine
% A badline will take 40 of these. = 27-31 clocks left on a badline

% If we put the mixing routine into above, we have 27 clocks to use for it
% ...and we need to save X and Y as well.
% STX ZeroPage    3
% STY ZeroPage    3
% LDY #0          2
% LDX #0          2
% We have 17-21 clocks left before a badline play will touch the 
% end of another.
% This could be fixed by having the replay routine
% play two samples, and making one "badline version" of the IRQ
% and one "non-badline" version.



% 100% without pitch table: (can only pitch between 50%-100% speed)
%                    ;clks
% loop:
%   inx                ;2
%   adc #$4c           ;2
%   bcc noFaster       ;2+1ifBranch
%   inx                ;2
% noFaster: 
%   ldy waveForm,x     ;4+1ifCrossingPageBoundary
%   sty poi+1          ;3
% poi:
%   ldy volumeTable    ;4
% poi2:
%   sty $b800          ;5
%   inc poi2+1         ;5
%   bpl loop           ;2+1ifBranch
%                      = 33 clks per iteration



% 100% with PHA and compressed pitch tables
% ROM:005C loc_5C:                                      ;clks
%   LDA #1                                     ;2
%   ROR $AF %Compressed pitch value, bit=0:add#1, bit=1:add#2   ;5
%   ADC poi+1                                  ;3
%   STA poi+1                                  ;3
% poi:
%   LDY  #$20                                  ;2
%   LDX     $2E00,Y  % WaveTable0 value        ;4
%   LDA     $0A00,X  % Volume/distortion table ;4
%   PHA     %Output buffer                     ;3
% ...unroll *8                                =26 clks per iteration


% 100% with PHA, and 128 bytes output length
% ROM:005C loc_5C:                                      ;clks  bytes
% ROM:005C   LDY     $AE00,X  % The pitch table         ;4       3
% ROM:005F   LDX     $2E00,Y  % WaveTable0 value        ;4       3
% ROM:0075   LDA     $0A00,X  % Volume/distortion table ;4       3
%                                           % NOTE x2 in output level!
% ROM:0078   PHA     %Output buffer                     ;3       1
% ROM:007B   TSX                                        ;2       1
% ROM:007C   BMI / BPL     loc_5C                       ;2+1ifTaken
% ROM:007E   RTS                                       =20 clks per iteration
% TSX does the following:
%    $reg->{ x } = $reg->{ sp };
%    $self->set_nz( $reg->{ x } );
% So both N and Z flags are set according to StackPointer
%The sign and zero flags reflect the result of the load
% Actually, this code does not need to be in ZeroPage.
% Unrolling it 64 times takes 64*11 = 704 bytes, and
% can be places anywhere in memory.
% This results in 17 clks per iteration.

% The other volume ratios will be a little more expensive
% in clks and memory, but using ~6kB for unrolled calculations
% seems ok - or they could be unrolled *16, having a four time counter
% somewhere.
% But, writing the wavetable-value becomes expensive if it is unrolled
% too many times.

% Need 64 bytes loops, so it is easiest to only use
% $0100-013f + $0180-$01bf

% Mixing routine becomes easy, replay will be
% Poi:
%        LDA     $3000            4
%        STA     $D401            4
%        DEC     Poi+1            5
% Branch:
%        BMI  wrap
% Save_anmi:
%        LDA #0
%        RTI
% Wrap:
%        lda Poi+1
%        and #$bf
%        sta Poi+1
%        lda Branch        %BMI=$30    BPL = $10
%        eor #$20
%        sta Branch
%        lda $save_anmi+1
%        rti


% 100%
% Y must be #$40 at start:
% ROM:005C loc_5C:                                     ;clks
% ROM:005C   LDX     $AE00,Y  % The pitch table        ;4
% ROM:005F   LDA     $2E93,X  % WaveTable0 value       ;4
% ROM:0074   TAX                                       ;2
% ROM:0075   LDA     $A00,X   %Volume/distortion table ;4
%                                           % NOTE x2 in output level!
% ROM:0078   STA     $B800,Y  %Output buffer           ;5
% ROM:007B   INY                                       ;2
% ROM:007C   BPL     loc_5C                            ;2+1ifTaken
% ROM:007E   RTS                                       =24 clks per iteration

% 75% + 25%
% Y must be #$40 at start:
% ROM:005C loc_5C:                                 ; CODE XREF: ROM:007Cj
% ROM:005C                 LDX     $AE00,Y  % The pitch table
% ROM:005F                 LDA     $2E93,X  % WaveTable1 value
%                          ASR
%                          ASR
% ROM:0065                 ADC     $3772,X  % WaveTable0 value
% ROM:0074                 TAX
% ROM:0075                 LDA     $A00,X   %Volume/distortion table
%                                           % NOTE x2/1.25 in output level!
% ROM:0078                 STA     $B800,Y  %Output buffer
% ROM:007B                 INY
% ROM:007C                 BPL     loc_5C
% ROM:007E                 RTS

% 66% + 33%
% Y must be #$40 at start:
% ROM:005C loc_5C:                                 ; CODE XREF: ROM:007Cj
% ROM:005C                 LDX     $AE00,Y  % The pitch table
% ROM:005F                 LDA     $2E93,X  % WaveTable1 value
%                          ASR
% ROM:0065                 ADC     $3772,X  % WaveTable0 value
% ROM:0074                 TAX
% ROM:0075                 LDA     $A00,X   %Volume/distortion table
%                                           % NOTE x2/1.5 in output level!
% ROM:0078                 STA     $B800,Y  %Output buffer
% ROM:007B                 INY
% ROM:007C                 BPL     loc_5C
% ROM:007E                 RTS


% 50% + 50%
% Y must be #$40 at start:
% ROM:005C loc_5C:                                 ; CODE XREF: ROM:007Cj
% ROM:005C                 LDX     $AE00,Y  % The pitch table
% ROM:005F                 LDA     $2E93,X  % WaveTable0 value
% ROM:0065                 ADC     $3772,X  % WaveTable1 value
% ROM:0074                 TAX
% ROM:0075                 LDA     $A00,X   %Volume/distortion table
%                                           % NOTE x1 in output level!
%                                           % could maybe use "no" volume
%                                           table for this one
% ROM:0078                 STA     $B800,Y  %Output buffer
% ROM:007B                 INY
% ROM:007C                 BPL     loc_5C
% ROM:007E                 RTS




% 100% without pitch table: (can only pitch between 50%-100% speed)
%                    ;clks
% loop:
%   inx                ;2
%   adc #$4c           ;2
%   bcc noFaster       ;2+1ifBranch
%   inx                ;2
% noFaster: 
%   ldy waveForm,x     ;4+1ifCrossingPageBoundary
%   sty poi+1          ;3
% poi:
%   ldy volumeTable    ;4
% poi2:
%   sty $b800          ;5
%   inc poi2+1         ;5
%   bpl loop           ;2+1ifBranch
%                      = 33 clks per iteration




